﻿using System;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace MakingAPostRequestWithBasicAuth
{
    class Program
    {
        private static readonly string Username = "aadams";
        private static readonly string Password = "kdshgs89g2qjaw09g";
        static async Task Main()
        {
            await PostRequest().ConfigureAwait(false);
        }

        public static async Task PostRequest()
        {
            HttpClient httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://postman-echo.com/")
            };

            httpClient.DefaultRequestHeaders.Add("Authorization", $"Basic {Base64Encode($"{Username}:{Password}")}");
            //Alternative way to add the authorization header 
            //httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", Base64Encode($"{Username}:{Password}"));

            PersonRequest request = new PersonRequest("Andrew", "Adams", 99);
            HttpResponseMessage httpResponseMessage = await httpClient.PostAsJsonAsync("/post", request).ConfigureAwait(false);
            PersonResponse personResponse = await httpResponseMessage.Content.ReadAsAsync<PersonResponse>().ConfigureAwait(false);
            Console.WriteLine(personResponse);
        }

        public static string Base64Encode(string textToEncode)
        {
            byte[] textAsBytes = Encoding.UTF8.GetBytes(textToEncode);
            return Convert.ToBase64String(textAsBytes);
        }
    }
}
